//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FullScreenUnit.h"
#include "imagewn.h"
#include "helpunit.h"
#include "splashunit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFullScreenForm *FullScreenForm;
//---------------------------------------------------------------------------

__fastcall TFullScreenForm::TFullScreenForm(TComponent* Owner) : TForm(Owner) {
  Top = 0;
  Left = 0;
  Height = Screen->Height;
  Width = Screen->Width;
}
//---------------------------------------------------------------------------

void TFullScreenForm::set_image() {
  Image1->Picture = ImageForm->Image1->Picture;
  FormResize(NULL);
  if (ImageForm->SlideShow1->Checked) { // viewing a slide show
    Label1->Caption = ImageForm->StatusBar1->Panels->Items[0]->Text + " - " +
                      ImageForm->ListView1->Selected->SubItems->Strings[1];
  }
  else {
    Label1->Caption = ImageForm->StatusBar1->Panels->Items[0]->Text + " - " +
                      ImageForm->StatusBar1->Panels->Items[1]->Text;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFullScreenForm::FormKeyPress(TObject *Sender, char &Key) {
  if (Key == 0x20 /* space */) {
    ImageForm->Next();
    set_image();
    Key = 0x0;
  }
  else if (Key == '\b') {
    ImageForm->Prev();
    set_image();
    Key = 0x0;
  }
  else if (Key == 'h' || Key == 'H') {
    Label1->Visible = !Label1->Visible;
    Label2->Visible = !Label2->Visible;
    Key = 0x0;
  }
  else if (Key == 'f' || Key == 'F' || Key == VK_RETURN) {
    Close();
    if (ImageForm->ListView1->Visible) {
      ImageForm->ListView1->SetFocus();
      ImageForm->scroll();
    }
    Key = 0x0;
  }
  else if (Key == VK_ESCAPE) {
    if (Application->MessageBox("Do you want to exit Kview?", "Question" , MB_YESNO) == IDYES) {
      ImageForm->Close();
    }
    Key = 0x0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFullScreenForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift) {
  if (Key == VK_F1) {
    HelpForm->Show();
    Key = 0x0;
  }
  else if (Key == VK_DOWN || Key == VK_RIGHT) {
    ImageForm->Next();
    set_image();
    Key = 0x0;
  }
  else if (Key == VK_UP || Key == VK_LEFT) {
    ImageForm->Prev();
    set_image();
    Key = 0x0;
  }
  else if (Key == VK_NEXT) {   // PgDn
    if (ImageForm->SlideShow1->Checked) { // viewing a slide show
      if (ImageForm->ListView1->Selected->Index + 5 < ImageForm->ListView1->Items->Count) {
        ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[ImageForm->ListView1->Selected->Index + 5];
      }
      else {
        ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[ImageForm->ListView1->Items->Count - 1];
      }
      ImageForm->scroll();
      ImageForm->ListView1Click(NULL);
    }
    else { // file browsing
      if (ImageForm->FileListBox1->ItemIndex + 5 < ImageForm->FileListBox1->Items->Count) {
        ImageForm->FileListBox1->ItemIndex = ImageForm->FileListBox1->ItemIndex + 5;
      }
      else {
        ImageForm->FileListBox1->ItemIndex = ImageForm->FileListBox1->Items->Count - 1;
      }
      ImageForm->FileListBox1Click(NULL);
    }
    set_image();
    Key = 0x0;
  }
  else if (Key == VK_PRIOR) {  // PgUp
    if (ImageForm->SlideShow1->Checked) { // viewing a slide show
      if (ImageForm->ListView1->Selected->Index >= 5) {
        ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[ImageForm->ListView1->Selected->Index - 5];
      }
      else {
        ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[0];
      }
      ImageForm->scroll();
      ImageForm->ListView1Click(NULL);
    }
    else { // file browsing
      if (ImageForm->FileListBox1->ItemIndex >= 5) {
        ImageForm->FileListBox1->ItemIndex = ImageForm->FileListBox1->ItemIndex - 5;
      }
      else {
        ImageForm->FileListBox1->ItemIndex = 0;
      }
      ImageForm->FileListBox1Click(NULL);
    }
    set_image();
    Key = 0x0;
  }
  else if (Key == VK_HOME) {
    if (ImageForm->SlideShow1->Checked) { // viewing a slide show
      ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[0];
      ImageForm->scroll();
      ImageForm->ListView1Click(NULL);
    }
    else { // file browsing
      ImageForm->FileListBox1->ItemIndex = 0;
      ImageForm->FileListBox1Click(NULL);
    }
    set_image();
    Key = 0x0;
  }
  else if (Key == VK_END) {
    if (ImageForm->SlideShow1->Checked) { // viewing a slide show
      ImageForm->ListView1->Selected = ImageForm->ListView1->Items->Item[ImageForm->ListView1->Items->Count - 1];
      ImageForm->scroll();
      ImageForm->ListView1Click(NULL);
    }
    else { // file browsing
      ImageForm->FileListBox1->ItemIndex = ImageForm->FileListBox1->Items->Count - 1;
      ImageForm->FileListBox1Click(NULL);
    }
    set_image();
    Key = 0x0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFullScreenForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y) {
  if (Button == mbRight) {
    ImageForm->Prev();
    set_image();
  }
  else if (Button == mbLeft) {
    ImageForm->Next();
    set_image();
  }
}
//---------------------------------------------------------------------------

void __fastcall TFullScreenForm::FormResize(TObject *Sender) {
  int w = Screen->Width;
  int h = Screen->Height;
  // adjust size of Image1 to correct proportion
  if (Image1->Picture->Width < w && Image1->Picture->Height < h) {
    Image1->Width = Image1->Picture->Width;
    Image1->Height = Image1->Picture->Height;
  }
  else if (Image1->Picture->Width * 1000 / Image1->Picture->Height > w * 1000 / h) { // wide
    Image1->Width = w;
    Image1->Height = w * Image1->Picture->Height / Image1->Picture->Width;
  }
  else { //tall
    Image1->Width = h * Image1->Picture->Width / Image1->Picture->Height;
    Image1->Height = h;
  }
  Image1->Left = w / 2 - Image1->Width / 2;
  Image1->Top = h / 2 - Image1->Height / 2;
}
//---------------------------------------------------------------------------

void __fastcall TFullScreenForm::FormActivate(TObject *Sender) {
  set_image();
}
//---------------------------------------------------------------------------



