// Kview - Freeware by Kisko

/*
To Do
C:\pics\sum03\index.txt
C:\pics\sum03\sum03.ss
  put iview & read me on the cd
  fix error checking error at startup
  timer to display next slide every n seconds
  allow links to other slides shows via ssl files or ss links in a ss file
  be able to view txt and maybe htm via CppWebBrowser1->Navigate
  allow blanks in filenames via quoted filenames
  allow blanks in filenames via quoted filenames
  allow edits to picture descriptions
  allow creation of ss files
  allow append of new jpg files to an existing ss file
  ignore blank lines in or at end of ss file

  try BringToFront
  use diff dir sel component
*/

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h> // for _argc and _argv
#include <sysutils.hpp>
#include <jpeg.hpp>
#include "imagewn.h"
#include "helpunit.h"
#include "fullscreenunit.h"
#include "splashunit.h"

//---------------------------------------------------------------------
#pragma resource "*.dfm"
TImageForm *ImageForm;
int Memo1_header_lines;
AnsiString last_error;

long file_size(char * filename) {
  int handle;
  long size;
  handle = open(filename, O_RDONLY);
  size = filelength(handle);
  close(handle);
  return size;
}

//---------------------------------------------------------------------
void fget_line(char * line, int max, FILE * infile, bool & eof) {
  eof = fgets(line, max, infile) == NULL;
  int last = strlen(line) - 1;
  if (line[last] == '\n') line[last] = 0;
}

//---------------------------------------------------------------------
__fastcall TImageForm::TImageForm(TComponent *Owner) : TForm(Owner) {
}

//---------------------------------------------------------------------
void __fastcall TImageForm::FormCreate(TObject* /*Sender*/) {
  last_error = "";
  if (_argc == 1) {   // no args - show picture browser
  }
  else {
    open_slide_show(AnsiString(_argv[1]));
  }
  if (!SlideShow1->Checked) {
    show_picture_browser();
  }
}

//----------------------------------------------------------------------------
#pragma argsused
void __fastcall TImageForm::FileEditKeyPress(TObject* Sender, Char &Key) {
  if (Key == 0x13) {
    FileListBox1->ApplyFilePath(FileEdit->Text);
    Key = 0x0;
  }
}

//----------------------------------------------------------------------------
void __fastcall TImageForm::FileListBox1Click(TObject* /*Sender*/) {
  if (load_image(FileListBox1->FileName)) {
    StatusBar1->Panels->Items[0]->Text = AnsiString(FileListBox1->ItemIndex + 1) + " of " + FileListBox1->Items->Count;
    StatusBar1->Panels->Items[1]->Text = ExtractFileName(FileListBox1->FileName)
        + ", " + FileDateToDateTime(FileAge(FileListBox1->FileName))
        + " " + FileDateToDateTime(FileAge(FileListBox1->FileName)).TimeString()
        + ", " + Image1->Picture->Width + " x " + Image1->Picture->Height
        + ", " + file_size(FileListBox1->FileName.c_str()) + " bytes";
  }
  else {
    StatusBar1->Panels->Items[0]->Text = "0 of 0" ;
    StatusBar1->Panels->Items[1]->Text = " ";
    if (last_error == "") {
      last_error = "There are no " + FilterComboBox1->Mask + " files in " + FileListBox1->Directory;
    }
  }
}

//----------------------------------------------------------------------------
bool TImageForm::load_image(AnsiString file_spec) {
  AnsiString FileExt;
  bool ok = false;

  if (FileExists(file_spec)) {
    FileExt = ExtractFileExt(file_spec);
    FileExt = UpperCase(FileExt);

    if ( !strcmp(FileExt.c_str(),".JPG") ||
         !strcmp(FileExt.c_str(),".BMP") || !strcmp(FileExt.c_str(),".ICO")) {
      if (!strcmp(FileExt.c_str(),".JPG")) {
        TJPEGImage *JPEGImage = new TJPEGImage();
        JPEGImage->ProgressiveDisplay = false;
        JPEGImage->PixelFormat = jf24Bit;
        JPEGImage->LoadFromFile(file_spec);
        Image1->Picture->Assign(JPEGImage);
        JPEGImage->Free();
      }
      if ( !strcmp(FileExt.c_str(),".BMP") ) {
        Image1->Picture->LoadFromFile(FileListBox1->FileName);
      }
      if ( !strcmp(FileExt.c_str(),".ICO") ) {
        Image1->Picture->LoadFromFile(file_spec);
        Icon = Image1->Picture->Icon;
      }
      Image1->Visible = true;
      FormResize(NULL);
      ok = true;
    }
  }
  return ok;
}

//---------------------------------------------------------------------------
void TImageForm::scroll() {
  if (ListView1->Selected->Position.y < 90) {
    ListView1->Scroll(0, ListView1->Selected->Position.y - 90);
  }
  if (ListView1->Selected->Position.y > 100) {
    ListView1->Scroll(0, ListView1->Selected->Position.y - 90);
  }
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::Prev() {
  if (SlideShow1->Checked) { // viewing a slide show
    if (ListView1->Selected->Index > 0) {
      ListView1->Selected = ListView1->Items->Item[ListView1->Selected->Index - 1];
    }
    else {
      if (Application->MessageBox("You are viewing the first picture. Jump to last?", "Question" , MB_YESNO) == IDYES) {
        ListView1->Selected = ListView1->Items->Item[ListView1->Items->Count - 1];
      }
    }
    scroll();
    ListView1Click(NULL);
  }
  else { // file browsing
    if (FileListBox1->ItemIndex > 0) {
      FileListBox1->ItemIndex = FileListBox1->ItemIndex - 1;
    }
    else {
      if (Application->MessageBox("You are viewing the first picture. Jump to last?", "Question" , MB_YESNO) == IDYES) {
        FileListBox1->ItemIndex = FileListBox1->Items->Count - 1;
      }
    }
    FileListBox1Click(NULL);
  }
}

//----------------------------------------------------------------------------
void __fastcall TImageForm::Next() {
  if (SlideShow1->Checked) { // viewing a slide show
    if (ListView1->Selected->Index + 1 < ListView1->Items->Count) {
      ListView1->Selected = ListView1->Items->Item[ListView1->Selected->Index + 1];
    }
    else {
      if (Application->MessageBox("You are viewing the last picture. Jump to first?", "Question" , MB_YESNO) == IDYES) {
        ListView1->Selected = ListView1->Items->Item[0];
      }
    }
    scroll();
    ListView1Click(NULL);
  }
  else { // file browsing
    if (FileListBox1->ItemIndex + 1 < FileListBox1->Items->Count) {
      FileListBox1->ItemIndex = FileListBox1->ItemIndex + 1;
    }
    else {
      if (Application->MessageBox("You are viewing the last picture. Jump to first?", "Question" , MB_YESNO) == IDYES) {
        FileListBox1->ItemIndex = 0;
      }
    }
    FileListBox1Click(NULL);
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::KviewHelp1Click(TObject *Sender) {
  HelpForm->Show();
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::About1Click(TObject *Sender) {
  ShowMessage ("Kview, Freeware by Thomas Kisko\nVersion 1.3\nOctober 20, 2003\nhttp://www.ise.ufl.edu/kisko/\nkisko@ise.ufl.edu") ;
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::FormKeyPress(TObject *Sender, char &Key) {
  if (Key == 0x20 /* space */) {
    Next();
    Key = 0x0;
  }
  else if (Key == '\b') {
    Prev();
    Key = 0x0;
  }
  else if (Key == 'b' || Key == 'B') {
    PictureBrowser1Click(NULL);
    Key = 0x0;
  }
  else if (Key == 's' || Key == 'S') {
    SlideShow1Click(NULL);
    FullScreenForm->Show();
    Key = 0x0;
  }
  else if (Key == 'f' || Key == 'F' || Key == VK_RETURN) {
    FullScreenForm->Show();
    Key = 0x0;
  }
  else if (Key == VK_ESCAPE) {
    if (Application->MessageBox("Do you want to exit Kview?", "Question" , MB_YESNO) == IDYES) {
      Close();
    }
    Key = 0x0;
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift) {
  if (Key == VK_F1) {
    HelpForm->Show();
    Key = 0x0;
  }
  else if (Key == VK_DOWN || Key == VK_RIGHT) {
    Next();
    Key = 0x0;
  }
  else if (Key == VK_UP || Key == VK_LEFT) {
    Prev();
    Key = 0x0;
  }
  else if (Key == VK_NEXT) {   // PgDn
    if (SlideShow1->Checked) { // viewing a slide show
      if (ListView1->Selected->Index + 5 < ListView1->Items->Count) {
        ListView1->Selected = ListView1->Items->Item[ListView1->Selected->Index + 5];
      }
      else {
        ListView1->Selected = ListView1->Items->Item[ListView1->Items->Count - 1];
      }
      scroll();
      ListView1Click(NULL);
    }
    else { // file browsing
      if (FileListBox1->ItemIndex + 5 < FileListBox1->Items->Count) {
        FileListBox1->ItemIndex = FileListBox1->ItemIndex + 5;
      }
      else {
        FileListBox1->ItemIndex = FileListBox1->Items->Count - 1;
      }
      FileListBox1Click(NULL);
    }
    Key = 0x0;
  }
  else if (Key == VK_PRIOR) {  // PgUp
    if (SlideShow1->Checked) { // viewing a slide show
      if (ListView1->Selected->Index >= 5) {
        ListView1->Selected = ListView1->Items->Item[ListView1->Selected->Index - 5];
      }
      else {
        ListView1->Selected = ListView1->Items->Item[0];
      }
      scroll();
      ListView1Click(NULL);
    }
    else { // file browsing
      if (FileListBox1->ItemIndex >= 5) {
        FileListBox1->ItemIndex = FileListBox1->ItemIndex - 5;
      }
      else {
        FileListBox1->ItemIndex = 0;
      }
      FileListBox1Click(NULL);
    }
    Key = 0x0;
  }
  else if (Key == VK_HOME) {
    if (SlideShow1->Checked) { // viewing a slide show
      ListView1->Selected = ListView1->Items->Item[0];
      scroll();
      ListView1Click(NULL);
    }
    else { // file browsing
      FileListBox1->ItemIndex = 0;
      FileListBox1Click(NULL);
    }
    Key = 0x0;
  }
  else if (Key == VK_END) {
    if (SlideShow1->Checked) { // viewing a slide show
      ListView1->Selected = ListView1->Items->Item[ListView1->Items->Count - 1];
      scroll();
      ListView1Click(NULL);
    }
    else { // file browsing
      FileListBox1->ItemIndex = FileListBox1->Items->Count - 1;
      FileListBox1Click(NULL);
    }
    Key = 0x0;
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y) {
  if (Button == mbRight) {
    Prev();
  }
  else if (Button == mbLeft) {
    Next();
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::FormResize(TObject *Sender) {
  // adjust size of Image1 to correct proportion
  int w = Panel1->Width, h = Panel1->Height;
  if (Image1->Picture->Width < w && Image1->Picture->Height < h) {
    Image1->Width = Image1->Picture->Width;
    Image1->Height = Image1->Picture->Height;
  }
  else if (Image1->Picture->Width * 1000 / Image1->Picture->Height > w * 1000 / h) { // wide
    Image1->Width = w;
    Image1->Height = w * Image1->Picture->Height / Image1->Picture->Width;
  }
  else { //tall
    Image1->Width = h * Image1->Picture->Width / Image1->Picture->Height;
    Image1->Height = h;
  }
  Image1->Left = w / 2 - Image1->Width / 2;
  Image1->Top = h / 2 - Image1->Height / 2;
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::Prev1Click(TObject *Sender) {
  Prev();
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::Next1Click(TObject *Sender) {
  Next();
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::SlideShow1Click(TObject *Sender) {
  TOpenDialog *OpenDialog1 = new TOpenDialog(this);
  OpenDialog1->Title = "Select Slide Show File to Open";
  OpenDialog1->InitialDir = DirectoryListBox1->Directory;
  OpenDialog1->Filter = "Slid Show files (*.ss)|*.ss|All files (*.*)|*.*";
  if (OpenDialog1->Execute()) {
    open_slide_show(OpenDialog1->FileName);
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::PictureBrowser1Click(TObject *Sender) {
  if (SlideShow1->Checked) {
    show_picture_browser();
  }
}

//---------------------------------------------------------------------------
void TImageForm::open_slide_show(AnsiString file_spec) {
  bool ok = true;
  FILE *infile;
  const max_line_size = 10000;
  char line[max_line_size]; // line of the file
  char * p;
  TListItem *li;
  bool done;       // finished reading?
  bool eof;
  AnsiString dir_spec;
  AnsiString file_name;

  //change to dir of file_spec
  dir_spec = ExtractFilePath(file_spec);
  file_name = ExtractFileName(file_spec);
  SetCurrentDir(dir_spec);

  //open slide show file
  if (!(FileExists(file_name))) {
//crashes, why?    MessageBox(NULL, ("Cannot find " + file_name).c_str(), "ERROR" , MB_OK);
    last_error = "ERROR: Cannot find " + file_name;
    ok = false;
  }
  else if((infile = fopen((file_name).c_str(), "r")) == NULL) {
    //MessageBox(NULL, ("Cannot open " + file_name).c_str(), "ERROR" , MB_OK);
    last_error = "ERROR: Cannot open " + file_name;
    ok = false;
  }

  //load slide show title
  if (ok) {
    // read title
    fget_line(line, max_line_size, infile, eof);
    if (line[0] == '~') {
      Caption = "Kview Slide Show : " + AnsiString(line + 1);
      Memo1->Lines->Text = line + 1;
      Memo1->Lines->Append(" ");
    }
    else {
      last_error = "ERROR: Bad slide show definition file. No ~ in title line of " + file_name;
      ok = false;
    }
  }

  //load slide show description lines
  Memo1_header_lines = 2;
  if (ok) {
    // read ~lines
    do {
      fget_line(line, max_line_size, infile, eof);
      if (eof) {
        done = true;
      }
      else if (eof || line[0] != '~') {
        done = true;
      }
      else {
        Memo1->Lines->Append(line + 1);
        Memo1_header_lines++;
      }
    } while (!done);

    // read picture description lines
    ListView1->Items->Clear();
    done = eof;
    int i = 0;
    while (!done) {
      li = ListView1->Items->Add();
      p = line;
      while (*p && *p != ' ') p++;
      *p = 0;
      li->Caption =  ++i ;
      li->SubItems->Add (line) ;   // image filename
      li->SubItems->Add (p + 1) ;  // image description
      fget_line(line, max_line_size, infile, eof);
      if (eof) {
        done = true;
      }
    }
    fclose(infile);
  }
  if (ok) {
    SlideShow1->Checked = true;
    PictureBrowser1->Checked = false;
    ListView1->Left = 5;
    ListView1->Width = ImageForm->ClientWidth - 10;
    ListView1->Top = ImageForm->ClientHeight - StatusBar1->Height - 180;
    ListView1->Height = 180;
    Memo1->Left = 5;
    Memo1->Width = ImageForm->ClientWidth - 10;
    Memo1->Top = ListView1->Top - 100;
    Memo1->Height = 100;
    Panel1->Left = 5;
    Panel1->Width = ImageForm->ClientWidth - 10;
    Panel1->Top = 0;
    Panel1->Height = Memo1->Top - 5;
    ListView1->Visible = true;
    Memo1->Visible = true;
    FilterComboBox1->Visible = false;
    FileListBox1->Visible = false;
    DriveComboBox1->Visible = false;
    DirectoryListBox1->Visible = false;
    FileEdit->Visible = false;

    //select first pic
    ListView1->Selected = ListView1->Items->Item[0];
    ListView1Click(NULL);
  }
}

//---------------------------------------------------------------------------
void TImageForm::show_picture_browser() {
  FileListBox1->Directory = GetCurrentDir();
  SlideShow1->Checked = false;
  PictureBrowser1->Checked = true;
  Panel1->Left = 160;
  Panel1->Width = ImageForm->ClientWidth - 160;
  Panel1->Top = 0;
  Panel1->Height = ImageForm->ClientHeight - 20;
  ListView1->Visible = false;
  Memo1->Visible = false;
  FilterComboBox1->Visible = true;
  FileListBox1->Visible = true;
  DriveComboBox1->Visible = true;
  DirectoryListBox1->Visible = true;
  FileEdit->Visible = true;
  Caption = "Kview";
  FileListBox1->ItemIndex = 0;
  FileListBox1Click(NULL);
}

void __fastcall TImageForm::ListView1Click(TObject *Sender) {
  AnsiString filename = ListView1->Selected->SubItems->Strings[0];
  if (load_image(filename)) {
    StatusBar1->Panels->Items[0]->Text = ListView1->Selected->Caption + " of " + ListView1->Items->Count;
    StatusBar1->Panels->Items[1]->Text = filename
        + ", " + FileDateToDateTime(FileAge(filename))
        + " " + FileDateToDateTime(FileAge(filename)).TimeString()
        + ", " + Image1->Picture->Width + " x " + Image1->Picture->Height
        + ", " + file_size(filename.c_str()) + " bytes";
  }
  else {
    StatusBar1->Panels->Items[0]->Text = AnsiString("? of ") + ListView1->Items->Count;
    StatusBar1->Panels->Items[1]->Text = " ";
    last_error = "ERROR: Could not load " + filename;
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::DirectoryListBox1Change(TObject *Sender) {
  if (FileListBox1->Items->Count > 0) {
    FileListBox1->ItemIndex = 0;
    FileListBox1Click(NULL);
  }
  else {
    Image1->Visible = false;
    StatusBar1->Panels->Items[0]->Text = "0 of 0" ;
    StatusBar1->Panels->Items[1]->Text = " ";
    last_error = "There are no " + FilterComboBox1->Mask + " files in this folder.";
  }
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::Exit1Click(TObject *Sender) {
  Close();
}

//---------------------------------------------------------------------------
void __fastcall TImageForm::Timer1Timer(TObject *Sender) {
  FullScreenForm->Show();
  if (last_error != "") {
    SplashForm->Memo1->Lines->Append(last_error);
    SplashForm->Height = SplashForm->Memo1->Lines->Count * 14 + 30;
    SplashForm->Width = 600;
  }
  if (SlideShow1->Checked) {
    SplashForm->Memo1->Lines->Append("You are viewing:");
    SplashForm->Memo1->Lines->Append(" ");
    for (int i = 0; i < Memo1_header_lines; i++) {
      SplashForm->Memo1->Lines->Append(Memo1->Lines->Strings[i]);
    }
    SplashForm->Height = SplashForm->Memo1->Lines->Count * 14;
    SplashForm->Width = 600;
  }
  SplashForm->Show();
  Timer1->Enabled = false;
}

//---------------------------------------------------------------------------

void __fastcall TImageForm::FullScreenEnter1Click(TObject *Sender) {
  FullScreenForm->Show();
}
//---------------------------------------------------------------------------



